/* gettim.c */

/* Modified by Andrew Makhorin <mao@gnu.org>, October 2012. */

#include <time.h>

/* Small function designed to be called from Fortran as a   */
/* substitute for the DOS / VAX function called GETTIM. It  */
/* is called as                                             */

/*              CALL GETTIM( IHOUR, IMIN, ISEC)             */

/* where IHOUR, IMIN, and ISEC are all integer*4 variables  */
/* which are set by this routine.  The time which is        */
/* returned is the GMT time of day. -- Rick Slater, NRL     */

int gettim_(int *ihr, int *imin, int *isec)
{     time_t t;
      struct tm *ts;
      t = time(NULL);
      ts = gmtime(&t);
      *ihr = ts->tm_hour;
      *imin = ts->tm_min;
      *isec = ts->tm_sec;
      return 0;
}

/* eof */
