/* float.h (i386 version for GCC) */

/***********************************************************************
*  Copyright (C) 2013 Andrew Makhorin <mao@gnu.org>.
*
*  This code is distributed under the terms of the GNU General Public
*  License, version 3 or later.
***********************************************************************/

#ifndef _FLOAT_H
#define _FLOAT_H

#define FLT_RADIX       2
#define FLT_ROUNDS      1

#define FLT_MANT_DIG    24
#define FLT_MIN_EXP     (-125)
#define FLT_MAX_EXP     (+128)
#define FLT_DIG         6
#define FLT_MIN_10_EXP  (-37)
#define FLT_MAX_10_EXP  (+38)
#define FLT_EPSILON     ((float)*_Flt_eps)
#define FLT_MIN         ((float)*_Flt_min)
#define FLT_MAX         ((float)*_Flt_max)

extern const float *_Flt_eps;
extern const float *_Flt_min;
extern const float *_Flt_max;

#define DBL_MANT_DIG    53
#define DBL_MIN_EXP     (-1021)
#define DBL_MAX_EXP     (+1024)
#define DBL_DIG         15
#define DBL_MIN_10_EXP  (-307)
#define DBL_MAX_10_EXP  (+308)
#define DBL_EPSILON     ((double)*_Dbl_eps)
#define DBL_MIN         ((double)*_Dbl_min)
#define DBL_MAX         ((double)*_Dbl_max)

extern const double *_Dbl_eps;
extern const double *_Dbl_min;
extern const double *_Dbl_max;

#define LDBL_MANT_DIG   64
#define LDBL_MIN_EXP    (-16381)
#define LDBL_MAX_EXP    (+16384)
#define LDBL_DIG        18
#define LDBL_MIN_10_EXP (-4931)
#define LDBL_MAX_10_EXP (+4932)
#define LDBL_EPSILON    ((long double)*_Ldbl_eps)
#define LDBL_MIN        ((long double)*_Ldbl_min)
#define LDBL_MAX        ((long double)*_Ldbl_max)

extern const long double *_Ldbl_eps;
extern const long double *_Ldbl_min;
extern const long double *_Ldbl_max;

#endif

/* eof */
