/* math.h */

/***********************************************************************
*  Copyright (C) 2013 Andrew Makhorin <mao@gnu.org>.
*
*  This code is distributed under the terms of the GNU General Public
*  License, version 3 or later.
***********************************************************************/

#ifndef _MATH_H
#define _MATH_H

#define HUGE_VAL ((double)*_Huge_val)

extern const double *_Huge_val;

double acos(double);
double asin(double);
double atan(double);
double atan2(double, double);
double ceil(double);
double cos(double);
double cosh(double);
double exp(double);
double fabs(double);
double floor(double);
double fmod(double, double);
double frexp(double, int *);
double ldexp(double, int);
double log(double);
double log10(double);
double modf(double, double *);
double pow(double, double);
double sin(double);
double sinh(double);
double sqrt(double);
double tan(double);
double tanh(double);

#endif

/* eof */
