/* time.h */

/***********************************************************************
*  Copyright (C) 2013 Andrew Makhorin <mao@gnu.org>.
*
*  This code is distributed under the terms of the GNU General Public
*  License, version 3 or later.
***********************************************************************/

#ifndef _TIME_H
#define _TIME_H

#define NULL ((void *)0)

#define CLOCKS_PER_SEC 1000

#ifndef _SIZE_T
#define _SIZE_T
typedef unsigned size_t;
#endif

typedef unsigned clock_t;
typedef unsigned time_t;

struct tm
{     int tm_sec;
      int tm_min;
      int tm_hour;
      int tm_mday;
      int tm_mon;
      int tm_year;
      int tm_wday;
      int tm_yday;
      int tm_isdst;
};

char *asctime(const struct tm *);
clock_t clock(void);
char *ctime(const time_t *);
double difftime(time_t, time_t);
struct tm *gmtime(const time_t *);
struct tm *localtime(const time_t *);
time_t mktime(struct tm *);
size_t strftime(char *, size_t, const char *, const struct tm *);
time_t time(time_t *);

#endif

/* eof */
